/// <reference path="reference/node.d.ts" />
export declare module Avro {
    class BinaryReader {
        constructor(schemas: any, buffer: Uint8Array);
        public strictMode: boolean;
        public buffer: Uint8Array;
        public dataView: DataView;
        public idx: number;
        public schemas: any;
        public decode(schema: any, buffer: number[]): any;
        public readByte(): number;
        public utf8Decode(bytes: any): string;
        public typeOf(value: any): string;
        public read32le(): number;
        public readCount(): number;
        public readBoolean(): boolean;
        public readInt(): number;
        public readLong(): number;
        public readFloat(): number;
        public readDouble(): number;
        public readFixed(len: number): any[];
        public readBytes(): any[];
        public readString(): string;
        public readEnum(): number;
        public readArrayStart(): number;
        public arrayNext(): number;
        public readMapStart(): number;
        public mapNext(): number;
        public readArray(schema: any): any[];
        public readDatum(schema: any): any;
    }
    class BinaryWriter {
        constructor(schemas: any);
        public buffer: Uint8Array;
        public dataView: DataView;
        public _index: number;
        public schemas: {};
        public getBuffer(): NodeBuffer;
        public getArrayBuffer(): any;
        public alloc(size: number): void;
        public realloc(): void;
        public require(bytes: any): void;
        public encode(schema: any, datum: any): Uint8Array;
        public writeByte(b: any): void;
        public utf8Encode(value: string): string;
        public writeBoolean(value: any): void;
        public writeInt(value: any): void;
        public writeLong(value: any): void;
        public writeFloat(f: any): void;
        public writeDouble(value: any): void;
        public writeString(str: string): void;
        public writeIndex(idx: any): void;
        public writeMapStart(): void;
        public writeMapEnd(): void;
        public writeDatum(schema: any, datum: any): void;
    }
    interface Schema {
        fullName: string;
        name: string;
        namespace: string;
    }
    class SchemaCache {
        constructor(schemaArray: any[]);
        public importSchemas(filePath: string): void;
        public store(schema: any): void;
        public find(protocol: number, messageType: number): Schema;
    }
}
